#include <cstdio>
#include "conio.h"
#include <string>
#include <vector>
#include <iostream>
#include <queue>
#define DEBUG

using namespace std;

int main(int argc, char *argv[])
{
    printf("\n"
    "OMIKRON STEREO ADP->MONO ADP"
    " by TuxTheWise"
    "\n");
    
    //Check de arg
          
    #ifdef DEBUG
    argv[1] = "2.adp";
    #endif
    
    string saida_n(argv[1]);
    saida_n.erase(saida_n.end()-4,saida_n.end());
    saida_n.append("m.ADP");
    
    FILE *entrada = fopen(argv[1],"rb");
    if(!entrada)
    {
               cout << "Error opening " << argv[1] << "\n" << endl;
               #ifdef DEBUG
               getch();
               #endif
               return 0;
    }
    
    fseek(entrada, 0, SEEK_END);
    int tamanho = (int)ftell(entrada);
    fseek(entrada,16,SEEK_SET);
    
    unsigned char *vetor;
    vetor = (unsigned char *)malloc(tamanho * sizeof(unsigned char));
    
    int lido = fread(vetor,1,tamanho-16,entrada);
    fclose(entrada);
    
    if((lido % 2)) lido--;
    
    unsigned char *final = (unsigned char *)malloc((lido / 2)* sizeof(unsigned char));
    
    unsigned char nibble1, nibble2;
    int temp1,temp2;
    for(int i = 0; i < lido; i += 2)
    {
            temp1 = vetor[i] & (0x0F);
            temp2 = ((vetor[i] & (0xF0)) >> 4);
            temp1 = (temp1 + temp2) / 2;
            
            nibble1 = (unsigned char)temp1;
            
            temp1 = vetor[i+1] & (0x0F);
            temp2 = (vetor[i+1] & (0xF0)) >> 4;
            temp1 = (temp1 + temp2) / 2;
            
            nibble2 = (unsigned char)temp2;
            
            final[i/2] = ((nibble1 << 4) | (nibble2));
    }
    
    FILE *saida = fopen(saida_n.c_str(),"wb");
    int lido2 = lido / 2;
    fputc(lido2 & 0xFF,saida);
    fputc((lido2 >> 8) & 0xFF,saida);
    fputc((lido2 >> 16) & 0xFF,saida);
    fseek(saida,16,SEEK_SET);
    fwrite(final,1,lido2,saida);
    fclose(saida);
}
